superstrict


framework brl.blitz
import brl.glmax2d
import "common.bmx"
import "gui.bmx"




const ACTION_LAMP_NEW:int = 1
const ACTION_LIGHT_NEW:int = 2
const ACTION_PATHTILE_NEW:int = 3
const ACTION_EMPTYTILE_NEW:int = 4

const ACTION_LAMP_SETCOLOR:int = 1
const ACTION_LIGHT_SETCOLOR:int = 2
const ACTION_LIGHT_ADDSIDE:int = 3
const ACTION_PATHTILE_ADDTRACE:int = 4

const IMG_MAXWIDTH:int = 175
const IMG_MAXHEIGHT:int = 50

global colors_order:int[] = [COLOR_RED,COLOR_GREEN,COLOR_BLUE,COLOR_YELLOW,COLOR_PURPLE,COLOR_TURQUOISE,COLOR_WHITE]
global traces_order:int[] = [TRACE_2OP,TRACE_2N,TRACE_3,TRACE_4]




type TEditor
	field timer:TTimer
	field button_new:TButton
	field button_load:TButton
	field button_save:TButton
	field button_scramble:TButton
	field checkbox_wrap:TCheckbox
	field img_tilemenu:TImage
	field img_tilemenu_extra:TImage
	field img_tilemenu_lamp:TImage
	field img_tilemenu_light:TImage
	field img_tilemenu_path:TImage
	method new()
		timer = TTimer.create(10)
		button_new = TButton.create("New",10,10)
		button_load = TButton.create("Load",130,10)
		button_save = TButton.create("Save",250,10)
		button_scramble = TButton.create("Scramble",370,10)
		checkbox_wrap = TCheckbox.create("Wrap",490,10)
		img_tilemenu = loadimage("media/tilemenu.png")
		img_tilemenu_extra = loadimage("media/tilemenu_extra.png")
		img_tilemenu_lamp = loadimage("media/tilemenu_lamp.png")
		img_tilemenu_light = loadimage("media/tilemenu_light.png")
		img_tilemenu_path = loadimage("media/tilemenu_pathtile.png")
	endmethod
	method tile_chooser(x:int,y:int,tile:TTile,primary:int var,secondary:int var,args:int var)
		local dimmer:TDimmer = TDimmer.create()
		local second_image:TImage
		if TLamp(tile) then
			second_image = img_tilemenu_lamp
		elseif TLight(tile) then
			second_image = img_tilemenu_light
		elseif TPath(tile) then
			second_image = img_tilemenu_path
		endif
		local maxx:int = graphicswidth()-IMG_MAXWIDTH, maxy:int = graphicsheight()-IMG_MAXHEIGHT
		if x > maxx then x :- (x-maxx)
		if y > maxy then y :- (y-maxy)
		repeat
			timer.wait()
			local mx:int = mousex(), my:int = mousey(), mhit:int = mousehit(1)
			if mhit then
				if mouse_in_rect(mx,my,x,y,25,25) then
					primary = ACTION_LAMP_NEW
					second_image = img_tilemenu_lamp
				elseif mouse_in_rect(mx,my,x+25,y,25,25) then
					primary = ACTION_LIGHT_NEW
					second_image = img_tilemenu_light
				elseif mouse_in_rect(mx,my,x+50,y,25,25) then
					primary = ACTION_PATHTILE_NEW
					second_image = img_tilemenu_path
				elseif mouse_in_rect(mx,my,x+75,y,25,25) then
					primary = ACTION_EMPTYTILE_NEW
					exit
				elseif mouse_in_rect(mx,my,x,y+25,175,25) and second_image = img_tilemenu_lamp then
					secondary = ACTION_LAMP_SETCOLOR
					args = colors_order[(mx-x)/25]
					exit
				elseif mouse_in_rect(mx,my,x,y+25,200,25) and second_image = img_tilemenu_light then
					if mouse_in_rect(mx,my,x+75,y+25,25,25) then
						secondary = ACTION_LIGHT_ADDSIDE
					else
						secondary = ACTION_LIGHT_SETCOLOR
						args = colors_order[(mx-x)/25]
					endif
					exit
				elseif mouse_in_rect(mx,my,x,y+25,100,15) and second_image = img_tilemenu_path then
					secondary = ACTION_PATHTILE_ADDTRACE
					args = traces_order[(mx-x)/25]
					exit
				else
					exit
				endif
			endif
			cls
			dimmer.draw()
			setcolor 255,255,255
			drawimage img_tilemenu,x,y
			if second_image then drawimage second_image,x,y+25
			flip
		forever
		dimmer.cleanup()
		flushmouse()
	endmethod
	method text_input:string(message:string,starttext:string="")
		local dimmer:TDimmer = TDimmer.create()
		flushkeys()
		local inp:TInputfield = TInputfield.create(graphicswidth()/2-100,graphicsheight()/2-30,message,starttext)
		repeat
			timer.wait()
			inp.update()
			cls
			dimmer.draw()
			inp.draw()
			flip
		until keyhit(KEY_ENTER)
		dimmer.cleanup()
		return inp.gettext()
	endmethod
	method update()
		local mx:int = mousex(), my:int = mousey()
		local mhit1:int = mousehit(1), mhit2:int = mousehit(2), mhit3:int = mousehit(3)
		if appterminate() then end
		
		if gamefield then
			if mhit1 then gamefield.mouse(1,mx,my)
			if mhit2 then gamefield.mouse(2,mx,my)
			if mhit3 then
				local tile:TTile,tilex:int=mx,tiley:int=my
				tile = gamefield.tile_for_coordinates(tilex,tiley)
				local primary:int, secondary:int, args:int
				if tile then tile_chooser(mx,my,tile,primary,secondary,args)
				if primary then
					if TLamp(tile) then gamefield.lamps.remove(tile)
					if TLight(tile) then gamefield.lights.remove(tile)
				endif
				select primary
				case ACTION_LAMP_NEW
					tile = TLamp.create(tilex,tiley,COLOR_WHITE,0)
					gamefield.tiles[tilex,tiley] = tile
					gamefield.lamps.addlast(tile)
				case ACTION_LIGHT_NEW
					tile = TLight.create(tilex,tiley,COLOR_WHITE,new int[0])
					gamefield.tiles[tilex,tiley] = tile
					gamefield.lights.addlast(tile)
				case ACTION_PATHTILE_NEW
					tile = TPath.create(tilex,tiley,new int[0],new int[0])
					gamefield.tiles[tilex,tiley] = tile
				case ACTION_EMPTYTILE_NEW
					tile = TEmptyTile.create(tilex,tiley)
					gamefield.tiles[tilex,tiley] = tile
				endselect
				select secondary
				case ACTION_LAMP_SETCOLOR
					TLamp(tile).set_color(args)
				case ACTION_LIGHT_SETCOLOR
					TLight(tile).set_color(args)
				case ACTION_LIGHT_ADDSIDE
					TLight(tile).add_side(0)
				case ACTION_PATHTILE_ADDTRACE
					TPath(tile).add_trace(args,0)
				endselect
			endif
			
			if button_save.clicked(mhit1,mx,my) then
				local file:string = text_input("save level","lvl/")
				gamefield.save_to_file(file)
			endif
			if button_scramble.clicked(mhit1,mx,my) then gamefield.scramble()
			gamefield.wrap_enabled = checkbox_wrap.getstate()
		endif
		
		if button_new.clicked(mhit1,mx,my) then
			local width:int = int(text_input("width"))
			local height:int = int(text_input("height"))
			gamefield = TGamefield.create_empty(width,height)
		endif
		if button_load.clicked(mhit1,mx,my) then
			local file:string = text_input("load level","lvl/")
			gamefield = TGamefield.load_from_file(file)
			checkbox_wrap.setstate(gamefield.wrap_enabled)
		endif
		checkbox_wrap.update(mhit1,mx,my)
	endmethod
	method draw()
		cls
		button_new.draw()
		button_load.draw()
		button_save.draw()
		button_scramble.draw()
		checkbox_wrap.draw()
		if gamefield then
			gamefield.run()
			gamefield.draw(10,50)
		endif
		flip
	endmethod
	method main()
		repeat
			timer.wait()
			update()
			draw()
		forever
	endmethod
endtype




type TDimmer
	field image:TImage
	field dimming:float
	function create:TDimmer(dimming:float=0.5)
		local d:TDimmer = new TDimmer
		d.dimming = dimming
		d.photo()
		return d
	endfunction
	method photo()
		image = createimage(graphicswidth(),graphicsheight(),1,DYNAMICIMAGE)
		grabimage(image,0,0)
	endmethod
	method draw()
		setcolor 255*dimming,255*dimming,255*dimming
		drawimage image,0,0
	endmethod
	method cleanup()
		setcolor 255,255,255
		drawimage image,0,0
	endmethod
endtype



(new TEditor).main()

