superstrict


import brl.max2d




type TButton
	field x:int
	field y:int
	field width:int
	field height:int
	field text:string
	function create:TButton(text:string,x:int,y:int)
		local b:TButton = new TButton
		b.x = x
		b.y = y
		b.width = 100
		b.height = 30
		b.text = text
		return b
	endfunction
	method draw()
		setcolor 127,0,50
		drawrect x,y,100,30
		setcolor 255,255,255
		drawtext text,x+20,y+5
	endmethod
	method clicked:int(mhit:int,mx:int,my:int)
		return mhit and mx >= x and mx <= x+width and my >= y and my <= y+height
	endmethod
endtype



type TCheckbox
	field x:int
	field y:int
	field text:string
	field checked:int
	function create:TCheckbox(text:string,x:int,y:int,checked:int=false)
		local c:TCheckbox = new TCheckbox
		c.x = x
		c.y = y
		c.text = text
		c.checked = checked
		return c
	endfunction
	method update(mhit:int,mx:int,my:int)
		if mhit and mx >= x and mx <= x+100 and my >= y and my <= y+20 then
			checked = not checked
		endif
	endmethod
	method draw()
		setcolor 127,0,50
		drawrect x,y,30,30
		setcolor 255,255,255
		if checked then
			drawline x+5,y+5,x+25,y+25
			drawline x+25,y+5,x+5,y+25
		endif
		drawtext text,x+40,y+10
	endmethod
	method setstate(state:int)
		checked = state
	endmethod
	method getstate:int()
		return checked
	endmethod
endtype


type TInputfield
	const CURSOR_BLINK_TIME:int = 500
	field x:int
	field y:int
	field cursorstate:int
	field time_at_begin:int
	field message:string
	field text:string
	function create:TInputfield(x:int,y:int,message:string,starttext:string="")
		local i:TInputfield = new TInputfield
		i.x = x
		i.y = y
		i.message = message
		i.text = starttext
		return i
	endfunction
	method new()
		time_at_begin = millisecs()
	endmethod
	method update()
		local shifted:int = keydown(KEY_LSHIFT) or keydown(KEY_RSHIFT)
		if keyhit(KEY_BACKSPACE) and text.length > 0 then text = text[..text.length-1]
		if keyhit(KEY_SPACE) then text :+ " "
		'Buchstaben
		for local i:int = 65 to 90
			if keyhit(i) then
				if not shifted then i :+ 32
				text :+ chr(i)
				exit
			endif
		next
		'Zahlen und (ein) Sonderzeichen
		for local i:int = 48 to 57
			if keyhit(i) then
				if not shifted then
					text :+ chr(i)
				else
					if i = KEY_7 then text :+ "/"
				endif
				exit
			endif
		next
		cursorstate = ((millisecs()-time_at_begin) mod (2*CURSOR_BLINK_TIME)) > CURSOR_BLINK_TIME
	endmethod
	method draw()
		setcolor 0,0,0
		drawrect x,y,200,60
		setcolor 255,255,255
		drawtext message,x+5,y+5
		drawrect x+5,y+30,190,20
		setcolor 0,0,0
		drawrect x+6,y+31,188,18
		setcolor 255,255,255
		drawtext text,x+7,y+32
		if cursorstate = 1 then drawtext "|",x+7+text.length*8,y+32
	endmethod
	method gettext:string()
		return text
	endmethod
endtype









